1000 REMark to convert Flachkack files to DATAdesign files
1010 REMark this program uses the DATAdesign engine v3 or higher
1020 REMark -----------------------------------------------------------------
1030 REMark written by Joachim Van der Auwera
1040 REMark (c) Feb 1993 by PROGS, PROfessional & Graphical Software
1050 REMark -----------------------------------------------------------------
1060 :
1070 base=0 : k_nl=10 : dd_err=0
1080 CLS #0 : CLS #1 : CLS #2
1090 PRINT #0,'Type name of Flachback file to convert'
1100 INPUT #0,source$
1110 PRINT #0,'Type name for DATAdesign file'
1120 INPUT #0,dest$
1130 PRINT #0,'Converting...'
1135 :
1137 REMark we now introduce some code just to make Qlib think we use dd_err
1138 IF dest$='xyz@' THEN PRINT #2,dd_err
1140 :
1150 OPEN_IN #3,source$ : sourcelen=FLEN(#3) : CLOSE #3
1160 base=ALCHP(sourcelen)
1170 LBYTES source$,base
1180 :
1190 IF PEEK_L(base)<>HEX('466c426b') THEN 
1200    PRINT #0,'oops, not a Flashback file'
1210    Finish
1220 END IF 
1230 :
1240 length=PEEK_L(base+8)
1250 rsep=192 : lsep=PEEK(base+140)
1260 :
1270 : REMark now try to set the fields
1280 NEWfile dest$
1290 DIM fieldlog%(61), name$(16)
1300 addr=base+258+16
1310 FOR a=1 TO 61
1320    blen=PEEK_W(addr)
1330    name$=''
1340    FOR b=1 TO blen : name$=name$&CHR$(PEEK(addr+b+1))
1350    ADDfield name$,2
1360    IF NOT dd_err THEN PRINT 'field'!name$!'added'
1370    fieldlog%(a)=fieldID(name$)
1380    addr=addr+16
1390 END FOR a
1400 :
1410 : REMark now try to set the records
1420 todo=PEEK_L(base+12)    : REMark get number of records
1430 PRINT #2,todo!'records in file'\'converting record'
1440 addr=base+1234          : REMark start of records
1450 FOR a=1 TO todo
1460    lineno=1 : field$='' : REMark start with first line
1470    first=1
1480    AT #2,2,0 : PRINT #2,a
1490    addr=addr+1          : REMark skip rsep marker
1500    field=fieldlog%(1)   : REMark first field
1510    NEWrec
1520    REPeat CharLoop
1530       char=PEEK(addr)
1540       IF char<rsep THEN 
1550          field$=field$&CHR$(char)
1560       ELSE IF char=192 THEN 
1570          EXIT CharLoop
1580       ELSE IF field$<>'' THEN 
1590          IF field$(LEN(field$))=CHR$(k_nl) THEN field$=field$(1 TO LEN(field$)-1)
1600          SETline field$, field, lineno
1610          field=fieldlog%(char-rsep+1)
1620          field$=''
1630       ELSE 
1640          field=fieldlog%(char-rsep+1)
1650          field$=''
1660       END IF : END IF : END IF 
1670       IF char=lsep AND NOT first THEN lineno=lineno+1
1680       IF char=lsep AND first THEN first=0
1690       addr=addr+1
1700    END REPeat CharLoop
1710    IF field$<>'' THEN 
1720          IF field$(LEN(field$))=CHR$(k_nl) THEN field$=field$(1 TO LEN(field$)-1)
1730          SETline field$, field, lineno
1740    END IF 
1750    IMPLEMENT
1760 END FOR a
1770 :
1780 : REMark and save the stuff
1790 SAVEfile ,,1      : REMark automatic overwrite
1800 IF dd_err<>0 THEN 
1810    PRINT #0,'oops, error while saving file, press a key'
1820    CURSEN #0 : a$=INKEY$(#0,-1) : CURDIS #0
1830 END IF 
1840 :
1850 PRINT #0,'Done'
1860 Finish
1870 :
1880 : REMark here come the subroutines
1890 :
1900 DEFine PROCedure Finish
1910    : REMark routine to end this program
1920    REMark remove the buffers
1930    REPeat loop
1940       UNUSEbuffer #CYCLEbuffer
1950       IF dd_err THEN EXIT loop
1960    END REPeat loop
1970    REMark release base
1980    IF base THEN RECHP base
1990    STOP
2000 END DEFine Finish
2010 :
2020 DEFine PROCedure sa
2030    : REMark routine to save the file
2040    SAVE_O "flp1_ConvFlBk_bas"
2050 END DEFine sa
2060 :
